﻿Imports System.ComponentModel

Public Class Form5
    Dim heyamaphyoujikidouitiset As Boolean
    Private Sub Form5_Load(sender As Object, e As EventArgs) Handles Me.Load
        If (heyamaphyoujikidouitiset = False) Then
            With My.Settings
                Me.Location = .部屋マップ表示起動位置
                heyamaphyoujikidouitiset = True
                If (Form1.windowsizejidoutyousei = False) Then
                    Me.Size = .部屋マップ表示前回ウィンドウサイズ
                End If
            End With
            Call 部屋マップ表示設定読込()
        End If
    End Sub

    Private Sub Form5_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        Try
            If (Me.WindowState = FormWindowState.Normal) Then
                With My.Settings
                    .部屋マップ表示起動位置 = Me.Location
                    .部屋マップ表示前回ウィンドウサイズ = Me.Size
                End With
            End If
            If (PictureBox1.Image IsNot Nothing) Then
                PictureBox1.Image.Dispose()
                PictureBox1.Image = Nothing
            End If
        Catch
            If (Form1.errormessage) Then MsgBox(NameOf(Form5_Closing) & "：その他のエラーが発生しました。")
            Debug.Print("Form5_Closing：その他のエラーが発生しました。")
        End Try
    End Sub
    Sub 部屋マップ表示設定読込()
        Dim i As Integer, o As Form1
        o = Form1
        i = o.heyamapgridsize * 34
        With PictureBox1
            .Width = i + 1 + o.heyamapmargin * 2
            .Height = i + 4 + o.heyamapmargin * 2
            If (o.windowsizejidoutyousei) Then
                ClientSize = New Size(.Width, .Height)
            End If
        End With
    End Sub
    Private Sub PictureBox1_DoubleClick(sender As Object, e As EventArgs) Handles PictureBox1.DoubleClick
        With Form1
            If (.部屋マップ表示メイン(強制更新:=1) = 0) Then Call .エラーメッセージ表示()
        End With
    End Sub
    Private Sub Form5_DoubleClick(sender As Object, e As EventArgs) Handles Me.DoubleClick
        With Form1
            If (.部屋マップ表示メイン(強制更新:=1) = 0) Then Call .エラーメッセージ表示()
        End With
    End Sub

    Private Sub Form5_Shown(sender As Object, e As EventArgs) Handles Me.Shown
    End Sub

    Function 部屋マップ表示画像描画(Optional katamuki() As Integer = Nothing) As Integer
        Dim gridsize As Integer
        Dim heyabitmap As New Bitmap(PictureBox1.Width, PictureBox1.Height)
        Dim heyagraphics As Graphics = Graphics.FromImage(heyabitmap)
        Dim i As Integer, j As Integer, a As Integer, p() As Point, o As Form1
        Dim yukabrush As New SolidBrush(Form1.iro(27))
        Dim wakusenpen As New Pen(Form1.iro(28), 1)
        Dim utikabebrush As New SolidBrush(Form1.iro(29))
        Dim hosei As Integer = 1
        Try
            If (Form1.messagenumber <> 0) Then Return 0
            o = Form1
            gridsize = o.heyamapgridsize
            If (o.mapid <> 407 AndAlso o.mapid <> 408) Then '通常マップ
                For j = o.mapdataindex To UBound(Data.mapdata)
                    p = 頂点配列作成(Data.mapdata(j))
                    If (o.messagenumber <> 0) Then Return 0
                    If ((Data.mapdata(j)(1) And 2) <> 0) Then heyagraphics.FillPolygon(yukabrush, p)
                    If ((Data.mapdata(j)(1) And 4) <> 0) Then heyagraphics.FillPolygon(utikabebrush, p)
                    If ((Data.mapdata(j)(1) And 6) <> 0) Then heyagraphics.DrawPolygon(wakusenpen, p)
                    If ((Data.mapdata(j)(1) And 1) <> 0) Then Exit For
                Next
                If (j > UBound(Data.mapdata)) Then
                    Form1.messagenumber = 54
                    Return 0
                End If
            Else '斜めマップ
                If (o.mapid = 407) Then
                    a = 24
                Else '408
                    a = 25
                End If
                Using katamukebitmap As New Bitmap(a * gridsize + 2, 24 * gridsize + 2),
                    katamukegraphics As Graphics = Graphics.FromImage(katamukebitmap)
                    For j = o.mapdataindex To UBound(Data.mapdata)
                        p = 頂点配列作成(Data.mapdata(j), hosei:=hosei)
                        If (o.messagenumber <> 0) Then Return 0
                        If ((Data.mapdata(j)(1) And 2) <> 0) Then katamukegraphics.FillPolygon(yukabrush, p)
                        If ((Data.mapdata(j)(1) And 4) <> 0) Then katamukegraphics.FillPolygon(utikabebrush, p)
                        If ((Data.mapdata(j)(1) And 8) <> 0) Then katamukegraphics.DrawLines(wakusenpen, p)
                        If ((Data.mapdata(j)(1) And 6) <> 0) Then katamukegraphics.DrawPolygon(wakusenpen, p)
                        If ((Data.mapdata(j)(1) And 1) <> 0) Then Exit For
                    Next
                    If (j > UBound(Data.mapdata)) Then
                        Form1.messagenumber = 54
                        Return 0
                    End If
                    If (katamuki Is Nothing) Then katamuki = o.heyamapkatamukityousei
                    p = 頂点配列作成(Nothing, katamuki:=katamuki)
                    If (o.messagenumber <> 0) Then Return 0
                    heyagraphics.DrawImage(katamukebitmap, p)
                End Using
            End If

            For i = 0 To Form1.maxokimonosuu - 1
                If (o.okimono(i, 0) <> 0) Then
                    Select Case o.okimono(i, 0)
                        Case 213 'お金
                            If (o.moji(1).Length = 0) Then Continue For
                            Using heyabrush As New SolidBrush(o.iro(1))
                                heyagraphics.DrawString(o.moji(1), o.heyamapfont, heyabrush,
                                        New Point(o.okimono(i, 1) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseix,
                                                  o.okimono(i, 2) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseiy))
                            End Using
                        Case 206 '罠
                            If (o.moji(15).Length = 0) Then Continue For
                            Using heyabrush As New SolidBrush(o.iro(23))
                                heyagraphics.DrawString(o.moji(15), o.heyamapfont, heyabrush,
                                        New Point(o.okimono(i, 1) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseix,
                                                  o.okimono(i, 2) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseiy))
                            End Using
                        Case 201 '転移
                            If (o.moji(11).Length = 0) Then Continue For
                            Using heyabrush As New SolidBrush(o.iro(19))
                                heyagraphics.DrawString(o.moji(11), o.heyamapfont, heyabrush,
                                        New Point(o.okimono(i, 1) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseix,
                                                  o.okimono(i, 2) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseiy))
                            End Using
                        Case 204 '配置敵
                            If (o.moji(12).Length = 0) Then Continue For
                            Using heyabrush As New SolidBrush(o.iro(20))
                                heyagraphics.DrawString(o.moji(12), o.heyamapfont, heyabrush,
                                        New Point(o.okimono(i, 1) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseix,
                                                  o.okimono(i, 2) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseiy))
                            End Using
                        Case 212 'EXPボーナス
                            If (o.moji(0).Length = 0) Then Continue For
                            Using heyabrush As New SolidBrush(o.iro(0))
                                heyagraphics.DrawString(o.moji(0), o.heyamapfont, heyabrush,
                                    New Point(o.okimono(i, 1) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseix,
                                                o.okimono(i, 2) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseiy))
                            End Using
                        Case 214 '赤宝箱
                            If (o.moji(16).Length = 0) Then Continue For
                            Using heyabrush As New SolidBrush(o.iro(24))
                                heyagraphics.DrawString(o.moji(16), o.heyamapfont, heyabrush,
                                        New Point(o.okimono(i, 1) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseix,
                                                  o.okimono(i, 2) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseiy))
                            End Using
                        Case 202 '緑宝箱
                            If (o.moji(17).Length = 0) Then Continue For
                            Using heyabrush As New SolidBrush(o.iro(25))
                                heyagraphics.DrawString(o.moji(17), o.heyamapfont, heyabrush,
                                        New Point(o.okimono(i, 1) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseix,
                                                  o.okimono(i, 2) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseiy))
                            End Using
                        Case 208 '幸福きゃんきゃん
                            If (o.moji(13).Length = 0) Then Continue For
                            Using heyabrush As New SolidBrush(o.iro(21))
                                heyagraphics.DrawString(o.moji(13), o.heyamapfont, heyabrush,
                                        New Point(o.okimono(i, 1) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseix,
                                                  o.okimono(i, 2) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseiy))
                            End Using
                        Case 210 '冒険功績
                            If (o.moji(14).Length = 0) Then Continue For
                            Using heyabrush As New SolidBrush(o.iro(22))
                                heyagraphics.DrawString(o.moji(14), o.heyamapfont, heyabrush,
                                        New Point(o.okimono(i, 1) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseix,
                                                  o.okimono(i, 2) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseiy))
                            End Using
                        Case Else 'その他
                            If (o.moji(18).Length = 0) Then Continue For
                            Using heyabrush As New SolidBrush(o.iro(26))
                                heyagraphics.DrawString(o.moji(18), o.heyamapfont, heyabrush,
                                        New Point(o.okimono(i, 1) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseix,
                                                  o.okimono(i, 2) * gridsize + o.heyamapmargin + o.heyamapmojiitihoseiy))
                            End Using
                    End Select
                End If
            Next

            If (PictureBox1.Image IsNot Nothing) Then
                PictureBox1.Image.Dispose()
            End If
            PictureBox1.Image = heyabitmap
            Return 1
        Catch
            Form1.messagenumber = 51
            Return 0
        Finally
            If (yukabrush IsNot Nothing) Then yukabrush.Dispose()
            If (wakusenpen IsNot Nothing) Then wakusenpen.Dispose()
            If (utikabebrush IsNot Nothing) Then utikabebrush.Dispose()
            If (heyagraphics IsNot Nothing) Then heyagraphics.Dispose()
        End Try
    End Function
    Function 頂点配列作成(data() As Integer, Optional hosei As Integer = 0, Optional katamuki() As Integer = Nothing) As Point()
        Dim sabunyousosuu As Integer, gridsize As Integer, o As Form1, ykara As Integer, a As Integer
        Try
            o = Form1
            gridsize = o.heyamapgridsize
            If (katamuki Is Nothing) Then
                If (data Is Nothing) Then
                    Form1.messagenumber = 55
                    Return Nothing
                End If
                sabunyousosuu = UBound(data) + 1 - 10
                If (sabunyousosuu < 3) Then
                    Form1.messagenumber = 56
                    Return Nothing
                End If
                Dim p(sabunyousosuu - 2) As Point
                If (hosei = 0) Then hosei = o.heyamapmargin
                p(0) = New Point(data(10) * gridsize + hosei, data(11) * gridsize + hosei)
                If ((data(1) And 16) = 0) Then ykara = 1
                For i = 1 To sabunyousosuu - 2
                    If ((i And 1) = ykara) Then
                        p(i) = New Point(p(i - 1).X, p(i - 1).Y + data(i + 11) * gridsize)
                    Else
                        p(i) = New Point(p(i - 1).X + data(i + 11) * gridsize, p(i - 1).Y)
                    End If
                Next
                Return p
            Else
                Dim p(2) As Point
                a = 0
                If (o.mapid = 408) Then a = 6
                p = {New Point(17 * gridsize + CInt(gridsize * katamuki(a) * 0.2) + o.heyamapmargin,
                               CInt(gridsize * katamuki(1 + a) * 0.2) + o.heyamapmargin),
                    New Point(34 * gridsize + CInt(gridsize * katamuki(2 + a) * 0.2) + o.heyamapmargin,
                              17 * gridsize + CInt(gridsize * katamuki(3 + a) * 0.2) + o.heyamapmargin),
                    New Point(CInt(gridsize * katamuki(4 + a) * 0.2) + o.heyamapmargin,
                              17 * gridsize + CInt(gridsize * katamuki(5 + a) * 0.2) + o.heyamapmargin)}
                Return p
            End If
        Catch
            Form1.messagenumber = 53
            Return Nothing
        End Try
    End Function
End Class
Public Class Data
    Friend Shared mapdata()() As Integer = {'マップID,フラグ(1=最後,2=外枠,4=内枠,8=線分,16=Xから),転移北X,同Y,転移東X,同Y,転移南X,同Y,転移西X,同Y,起点X,起点Y,差分Y(X),差分X(Y),…
        New Integer() {1, 3, 0, 0, 13, 33, 0, 0, 17, 0, 0, 16, 2, 4, 2, 5, 1, 4, -1, 5, -3, 2, -2, 6, 5, 2, 2, 6, -2, -4, -2, -2, -5, -10, 2, -2, 3, -3, -1, -4, 1, -3, -2, -6},
        New Integer() {2, 3, 0, 0, 17, 33, 0, 0, 15, 0, 0, 17, 2, 3, 1, 4, -1, 4, -2, 5, 2, -1, 4, 4, -1, 5, -3, 4, -2, 6, -2, -8, 2, -4, 3, -3, -1, -1, -4, -3, -2, 2, -2, 3, 2, 6, -6, -6, 2, -5, 2, -2, 4, -4, 2, -2, -1, -4, 1, -3},
        New Integer() {81, 2, 28, 15, 13, 30, 3, 11, 13, 8, 8, 19, 6, 2, 6, 2, -5, 2, 1, 4, -4, -4, 1, -2, -1, -2, -2, 1, -1, 1, -1, 4, -1, 1, -1, 1, -1, 5, 1, 1, 1, 1, 3, 1, 1, 5, -2, -3, -1, -1, -3, -1, -1, -1, -1, -4, -1, -1, -1, -1, -5, -1, -1, -1, -1, -3, 1, -1, 1, -1, 4, 1, 1, 1, 1, 1, 3, -1, 1, -4, 1, -1, 1, -1},
        New Integer() {81, 5, 28, 15, 13, 30, 3, 11, 13, 8, 14, 7, 3, 3, -3, -3},
        New Integer() {82, 3, 31, 25, 14, 31, 2, 19, 18, 2, 2, 15, 2, 4, 4, 2, 2, 5, 1, 2, 4, 4, 4, 2, -6, -4, -2, 2, -2, 5, -3, 3, 2, 5, -2, -3, -2, -3, -6, -1, -3, 2, -6, -2, 4, -2, 7, 1, 4, -2, 3, -3, -1, -3, -2, 1, -1, 1, -2, 1, -5, -1, -1, -1, -1, -3, 1, -1, 1, -1, 5, 1, 2, 1, 1, 1, 2, -2, 2, -3, -2, -2, -4, -6},
        New Integer() {101, 3, 33, 19, 0, 0, 0, 18, 0, 0, 10, 9, 9, 3, 4, 5, 1, 1, 4, -2, 7, 2, -5, 2, -6, 1, -4, -4, 1, -3, -4, -3, -5, 4, 3, 8, -8, -3, -6, -2, 8, 3, 4, -4, -3, -8},
        New Integer() {102, 2, 33, 19, 0, 0, 0, 17, 0, 0, 14, 19, 9, 2, 3, 1, 3, 2, -5, -1, -3, -2, -5, 2, 3, 3, -1, 3, 1, 3, -3, -1, -5, 2, -3, -5, -7, -2, -6, -2, 8, 2, 5, -3, 6, -4},
        New Integer() {102, 5, 33, 19, 0, 0, 0, 17, 0, 0, 21, 16, 6, 3, -1, 1, -5, -4},
        New Integer() {201, 3, 28, 21, 16, 28, 5, 15, 21, 5, 5, 12, 2, 3, 3, 7, -2, 2, 5, 2, 3, -2, 2, -2, 4, 2, -2, 2, -2, 2, -4, 5, -2, 3, -2, -5, 2, -3, -1, -2, -3, 2, -4, 2, -6, -2, 4, -2, 4, -6, 2, -3, -3, -5},
        New Integer() {202, 2, 28, 18, 19, 28, 5, 16, 14, 5, 5, 19, 2, 6, 3, 4, 5, 2, -3, 4, 2, 7, -7, -2, -5, 3, -2, -5, -4, -1, -2, -4, -3, -2, 6, -4, 2, -4, 6, -4},
        New Integer() {202, 5, 28, 18, 19, 28, 5, 16, 14, 5, 11, 15, 4, 2, 3, 4, 2, 6, 3, 4, -4, -3, -5, -2, -6, -1, -2, -2, 3, -4, 2, -4},
        New Integer() {203, 2, 28, 23, 6, 26, 5, 8, 23, 5, 5, 10, 2, 8, -3, 3, 3, 2, 4, -5, 6, -5, 7, 2, -5, 3, 2, 5, 3, 9, -9, -3, -4, 2, -4, 3, -2, -3, -1, -2, -4, -2, 6, 2, 3, -2, 6, -4, 4, -3, -6, 5, -8, -2, -3, -7, 3, -6},
        New Integer() {203, 5, 28, 23, 6, 26, 5, 8, 23, 5, 20, 22, 5, 3, -2, 2, -3, -5},
        New Integer() {204, 3, 28, 16, 19, 28, 5, 24, 15, 5, 5, 18, 2, 4, 2, 7, -6, 2, -2, 4, 2, 1, 2, -3, 1, -1, 3, -1, 4, 3, -1, 2, 4, 2, -6, -4, -1, -1, -2, 1, -1, 4, -3, 4, -2, -5, -2, -6, -2, -1, -5, -2, 5, -3, 6, 2, 4, -3, -2, -6},
        New Integer() {301, 3, 29, 15, 11, 28, 5, 14, 15, 6, 6, 17, 2, 4, -2, 2, -6, 2, 2, 4, 3, -2, 6, -1, 2, -2, 5, 2, -3, 2, -2, 1, -1, 3, 1, 1, 1, 3, -1, 1, -1, 3, -1, -3, -1, -1, -1, -3, 1, -1, 1, -3, -4, 2, -7, -4, -7, -2, 5, -4, 6, -2, 2, -2},
        New Integer() {302, 2, 28, 22, 15, 28, 5, 7, 18, 5, 5, 15, 2, 4, 5, -2, 7, 2, -5, 2, 1, 1, 1, 1, 1, 1, 1, 9, -3, 1, -1, 2, -4, 3, -2, -3, -5, -3, -8, -2, 4, -5, 1, -4, 3, -2, 2, -5},
        New Integer() {302, 5, 28, 22, 15, 28, 5, 7, 18, 5, 11, 17, 5, 1, 1, 1, 1, 1, 1, 1, 1, 2, -4, -1, -1, -1, -3, 1, -1, 3, 1, 1, 3, -1, 1, -1, 4, 1, 1, 2, -1, 1, -3, 3, -3, -1, -5, -3, -4, -3, 1, -4, 3, -2, 2, -1},
        New Integer() {326, 2, 28, 20, 23, 28, 6, 17, 15, 6, 6, 18, 2, 3, 2, 2, 2, 5, 4, 2, -6, -2, -4, 2, 1, 5, -1, 1, -2, 3, -4, 2, -2, -4, 1, -3, -6, -2, 5, -4, 4, -2, 2, -5, 2, -3},
        New Integer() {326, 4, 28, 20, 23, 28, 6, 17, 15, 6, 11, 18, 2, 2, 2, 2, -4, -4},
        New Integer() {326, 5, 28, 20, 23, 28, 6, 17, 15, 6, 18, 12, 2, 1, 2, 3, -2, 3, -2, -7},
        New Integer() {327, 2, 28, 17, 20, 28, 6, 13, 12, 6, 6, 21, 2, 2, 2, 5, 3, 2, -5, 4, -4, 2, -1, 1, -5, -1, -2, 3, 4, 5, -2, -3, -4, -7, -4, -2, 6, 2, 2, -2, 1, -1, 1, -2, -1, -1, -1, -1, -1, -3, 1, -1, 1, -1, 3, 1, 1, 1, 1, 3, -1, 1, -1, 1, -1, 2, 3, 1, 2, -4, 2, -3, -2, -4},
        New Integer() {327, 5, 28, 17, 20, 28, 6, 13, 12, 6, 18, 15, 2, 2, -2, -2},
        New Integer() {401, 2, 26, 18, 9, 29, 8, 27, 18, 9, 6, 16, 6, 3, 3, 3, 3, 3, -5, -3, 1, -2, -3, -3, -4, 2, 2, 4, -1, 3, -2, 3, -1, 1, -3, 1, -2, 3, 2, -1, 3, -1, 4, 3, -1, 3, 2, -1, 3, -1, 3, 4, -3, -2, -2, 1, -4, -4, -2, -1, -2, 1, -4, -4, -2, -5, 1, -3, 2, -2, 4, -2, 2, -3},
        New Integer() {401, 5, 26, 18, 9, 29, 8, 27, 18, 9, 12, 11, 3, 1, 3, 2, -2, 3, -1, 1, -2, -1, -2, -2, -1, -2, 2, -2},
        New Integer() {402, 2, 24, 16, 19, 20, 4, 6, 18, 7, 3, 25, 3, 2, 2, 3, -2, 2, -3, -2, -2, -1, -2, 3, 2, 4, 2, 5, -4, -1, -2, 2, -3, 1, -3, -3, 3, 1, 2, -3, -3, -1, -1, -3, -1, -2, -3, 2, 1, 3, 1, 3, -3, -3, 1, -2, -1, -4, 4, -2, 5, 1, 2, -2, 3, -1, 2, -2},
        New Integer() {402, 5, 24, 16, 19, 20, 4, 6, 18, 7, 9, 18, 2, 2, 2, 3, -1, 3, -2, -2, -3, -1, -1, -2, 1, -2, 2, -1},
        New Integer() {403, 3, 28, 9, 25, 29, 5, 24, 9, 13, 8, 5, 3, 3, -1, 2, 3, -1, 3, -1, 3, 5, -3, -3, -2, 1, -2, 3, -1, 2, 3, 3, -1, 2, 3, 3, 4, -2, -2, -4, 5, 1, 3, -2, 2, -2, -1, -2, -2, -1, -3, -1, 3, -1, 5, 5, -1, 2, 2, 3, 1, 3, -3, -3, 1, -2, -3, 2, -4, 2, -2, 3, -5, 1, -3, 1, -3, -3, 3, 1, 2, -3, -3, -3, -2, 3, -3, -6, 3, -3, 1, -2, -2, -3, -1, -3},
        New Integer() {404, 2, 22, 14, 18, 26, 4, 8, 13, 7, 7, 16, 6, 2, 3, 3, 3, -2, -1, -3, 3, 3, -1, 3, -1, 5, -4, 1, -1, 5, -2, 2, -3, 1, -4, -2, -1, -3, 1, -3, 1, -1, 3, -3, -4, 1, -3, -3, 1, -3, 1, -2, 3, -1},
        New Integer() {404, 4, 22, 14, 18, 26, 4, 8, 13, 7, 8, 17, 2, 2, 5, 3, 3, 4, -3, -2, -3, 1, -2, -2, -5, -1, -1, -2, 1, -2, 3, -1},
        New Integer() {404, 5, 22, 14, 18, 26, 4, 8, 13, 7, 17, 19, 2, 2, 1, 4, -2, 2, -4, -3, -1, -2, 1, -1, 3, -2},
        New Integer() {405, 2, 28, 7, 14, 23, 6, 13, 27, 6, 5, 12, 5, 1, 5, 3, 3, 3, 3, 3, -1, 3, -1, 3, -2, 1, -3, 2, -3, -5, 1, -3, -3, 3, -1, 1, -3, 1, -3, -2, -2, -3, 1, -2, -2, -5, -1, -3, 4, 1, 3, -2},
        New Integer() {405, 4, 28, 7, 14, 23, 6, 13, 27, 6, 6, 13, 3, 3, -2, 3, 1, 1, 2, 2, -2, 3, -1, 1, -2, -1, -2, -2, -1, -3, -2, -4, 2, -1, 4, -2},
        New Integer() {405, 5, 28, 7, 14, 23, 6, 13, 27, 6, 7, 17, 4, 3, 3, 2, -1, 3, 3, 2, -1, 3, -2, 1, -2, -2, -1, -4, -2, -2, 1, -3, -1, -1, -1, -2},
        New Integer() {406, 2, 26, 15, 14, 26, 6, 17, 14, 7, 7, 19, 2, 3, 1, 1, 2, 3, 1, 2, 3, 2, -3, 1, -2, -1, -3, 3, 1, 3, -1, 3, -2, -3, -1, -2, -1, -1, -3, -3, -2, -2, -4, -2, 6, -2, 4, -2, 2, -3},
        New Integer() {406, 4, 26, 15, 14, 26, 6, 17, 14, 7, 12, 19, 3, 3, -3, -3},
        New Integer() {406, 5, 26, 15, 14, 26, 6, 17, 14, 7, 16, 15, 3, 3, -3, -3},
        New Integer() {407, 2, 27, 23, 12, 28, 5, 13, 25, 9, 0, 8, 6, 4, -3, 3, 4, -3, 3, -4, 2, 4, 1, 2, 3, 4, -3, -2, -2, -2, -2, 3, -2, 5, -2, 3, 2, 2, 5, -1, -1, -1, -3, -4, 4, 3, 1, 1, 3, 2, -2, 2, -3, 3, -2, -3, -4, -2, -2, -2, -4, 2, 2, 5, -2, -3, -7, -2, 3, -2, 2, -2, -3, -4, -2, -4, 2, -3, 2, -2, 4, -2},
        New Integer() {407, 5, 27, 23, 12, 28, 5, 13, 25, 9, 4, 6, 3, 4, -3, 4, 4, -3, 3, 3, -2, 3, -4, -2, -3, -7, 2, -2},
        New Integer() {408, 2, 29, 20, 12, 30, 1, 16, 17, 1, 0, 0, 5, 1, 4, 2, 3, -3, 6, 3, 2, -3, 4, 10, -2, 3, -2, 4, 2, 2, 2, 5, -8, -3, -3, 2, -4, 2, -6, -3, -3, -5, 2, -4, 2, -4, -2, -2, -2, -2, 7, -2, -5, -1, -2, -2},
        New Integer() {408, 4, 29, 20, 12, 30, 1, 16, 17, 1, 5, 18, 4, 2, -4, -2},
        New Integer() {408, 4, 29, 20, 12, 30, 1, 16, 17, 1, 7, 9, 3, 2, -2, 2, -3, -2, 2, -2},
        New Integer() {408, 4, 29, 20, 12, 30, 1, 16, 17, 1, 13, 7, 1, 4, -4, -2, 3, -2},
        New Integer() {408, 4, 29, 20, 12, 30, 1, 16, 17, 1, 13, 16, 2, 4, -2, -4},
        New Integer() {408, 4, 29, 20, 12, 30, 1, 16, 17, 1, 21, 5, 2, 2, -2, -2},
        New Integer() {408, 24, 29, 20, 12, 30, 1, 16, 17, 1, 2, 14, 5, 2, 2, -6, 2, -3, -6},
        New Integer() {408, 24, 29, 20, 12, 30, 1, 16, 17, 1, 2, 16, 3, 2, 2, 2, 6},
        New Integer() {408, 8, 29, 20, 12, 30, 1, 16, 17, 1, 13, 4, 10, -2, 4, 2, -2, 2, -7, 4, -4},
        New Integer() {408, 9, 29, 20, 12, 30, 1, 16, 17, 1, 21, 7, 4, -4, 3, 2, 4, 2, 4, 3},
        New Integer() {409, 3, 30, 10, 24, 30, 3, 20, 17, 4, 3, 4, 3, 1, 3, 2, 2, 3, 5, 2, 1, 4, 1, -1, 1, -4, 1, -2, -2, -2, -1, 1, -3, -3, 3, 1, 3, 1, 2, 4, 3, -6, 2, -1, 3, 4, -3, -1, -1, 7, -2, 3, 2, 3, 2, -2, -1, -3, 2, 4, 1, 4, -3, -1, -2, -3, -2, -6, -2, 2, 1, 3, -1, 2, 3, 3, 1, 2, 2, -1, 2, 3, -2, -1, -3, -1, -1, -3, -1, -1, -5, 2, -1, 2, 1, -1, 1, -1, 3, 1, 1, 3, -1, 1, -1, 2, 3, -1, 2, 2, -7, -3, -1, -2, -5, 2, 2, 1, 2, 2, -4, -2, -1, -4, 3, -2, -1, -4, 4, 1, 2, -2, -1, -1, -5, 1, -1, 4, -3, 4, -3, 1, -1, 1, 1, 1, 1, -1, 3, 4, -3, -1, -1, 1, -4, -4, 2, -3, 3, -2, 1, -1, -1, -1, 3, -3, -1, -3, 1, -1, 2, 1, 1, 1, 2, -2, -1, -2, -5, 2, -1, 3, -2, 1, -1, 1, -2, -4, 3, 1, 1, -4, -1, 1, -4, -3, 4, 1, 3, -2, -2, -2, -1, 1, -3, -4}
        }
    Friend Shared itemsikibetuflagindex()() As Integer = {
        New Integer() {0, 1, 4, 5, 8, 9, 11, 14, 15, 16, 19, 20, 21, 25, 26, 30, 31, 32, 33, 36, 37, 38, 39, 41, 43, 46, 47, 50, 51, 53, 55, 58},
        New Integer() {59, 61, 62, 63, 0, 66, 71, 72, 75, 76, 77, 81, 82, 85, 86, 87, 90, 91, 92, 93, 95, 96, 98, 99, 101, 103, 106, 107, 108, 111, 112, 113},
        New Integer() {115, 117, 119, 122, 123, 124, 127, 128, 130, 133, 137, 138, 139, 142, 143, 145, 148, 149, 151, 152, 153, 155, 156, 158, 160, 161, 163, 164, 166, 167, 0, 189},
        New Integer() {191, 193, 196, 200, 201, 202, 203, 204, 205, 211, 212, 213, 252, 305, 343, 0, 269, 270, 271, 272, 273, 274, 275, 276, 277, 278, 279, 280, 281, 282, 283, 284},
        New Integer() {285, 286, 287, 288, 289, 290, 291, 292, 293, 294, 295, 296, 297, 298, 299, 300, 301, 323, 324, 325, 326, 327, 328, 329, 330, 331, 332, 333}
        }
    Friend Shared expflagindex()() As Integer = {
        New Integer() {7, 61, 58, 40, 94, 3, 49, 26, 11, 28, 44, 10, 62, 25, 52, 5, 24, 41, 73, 51, 86, 80, 50, 70, 53, 0, 0},'27*3
        New Integer() {33, 23, 4, 20, 55, 71, 19, 32, 39, 46, 22, 14, 35, 48, 85, 6, 9, 18, 38, 36, 13, 17, 16, 84, 67, 68, 59},
        New Integer() {56, 42, 47, 45, 29, 34, 43, 31, 57, 60, 30, 15, 54, 12, 93, 81, 21, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109}
        }
    Friend Shared itemname() As String = {
        "", "冒険服", "ステルススーツ", "タランピスーツ", "巫女服", "Ｔシャツ", "メイド服", "リアの服", "革鎧", "革鎧ＸＡ",
        "セーラ服", "忍者服", "レジスト鎧", "上級冒険服", "硬革鎧", "硬革鎧ＸＢ", "キュルタックス", "ザ・忍者", "", "複合革鎧",
        "ＤＲ革鎧", "複合革鎧－改", "神木の鎧", "", "ラソウコウ", "ライトアーマー", "ライトアーマーＸＡ", "織田鎧", "", "",
        "アイアンアーマー", "アイアンアーマーＸ", "クリスタル鎧", "武者鎧", "リーザス赤将鎧", "", "コースアーマー", "ヘルセッター", "重量鎧", "ビキニ鎧",
        "チャンピオン", "コースアーマー改", "戦国ランス鎧", "プレランローブ", "", "", "ルースローブ", "スプリットローブ", "聖なる衣", "",
        "高級ルースローブ", "マホウバカ", "魔法大臣", "黒ローブ", "オルガリズム", "白帯道場着", "指揮官着", "合成強化服", "黒帯道場着", "チャイナ服",
        "", "赤帯道場着", "必殺道着", "皆伝着", "ウランバートル", "", "短剣", "よくあたる短剣", "こんぼう", "お神籤箱",
        "リアの鞭", "ショートソード", "忍者小刀", "", "両手盾", "レイピア", "レイピア改", "クリティカルナイフ", "連文節レイピア", "",
        "", "ビラブレイド", "スカートメクリ", "ウルンセルの刃", "首切り刀", "オバブレイド", "ロングソード", "イナズマの剣", "ゾンビーソード", "",
        "バスターソード", "バスターソード改", "日本刀", "氷山の剣", "かみ斬り", "スーパーソード", "ヒデオの剣", "ペルシオン", "ウルトラソード", "英雄の剣",
        "魔剣カオス", "力持ちハンマー", "玉露の斧", "神官のメイス", "必殺のハンマー", "", "ハンマーＢ", "ハンマーＢ改", "軟体潰し", "神父のメイス",
        "神父メイスＤ", "ビッグハンマー", "ベッキー", "司教のメイス", "コメットさん", "１０ｔハンマー", "", "戦士の槍", "毒だんご", "炎の槍",
        "", "", "スピア", "スピア改", "光の槍", "薙刀", "", "ハルバート", "アンギラス", "恐怖の槍",
        "ハルバートＳ", "バイ・ロード", "", "ショートボウ", "カラー精鋭弓", "耳狩りブーメラン", "", "ロングボウ", "ロングボウ改", "虫殺しの弓",
        "古きを狩る弓", "", "パワーアタックボウ", "匠の弓", "ストロンガー", "ギガアタックボウ", "", "", "グローブ", "善意のパンチ",
        "", "ナックル", "ナックル改", "コンフィグ", "", "メタルグローブ", "惨殺フィグ", "ドラゴン手袋", "ベテラングローブ", "",
        "ハイエスの杖", "魔法のアイス棒", "", "シルフの杖", "輝くＬＥＤの杖", "女王の杖", "ガイヤの杖", "長の杖", "仏陀", "クリスタルロッド",
        "火縄銃", "チューリップ１号", "超魔抵の指輪", "", "", "", "", "", "パンチャー", "ステルス装置",
        "はるまき", "世色癌箱", "世色癌ＥＸ箱", "世色癌ＥＸ＋箱", "蘇生薬", "魔法の鍵", "捕獲ロープ", "炸裂弾", "ハニージッポ", "魔抵の指輪",
        "魔抵の指輪", "回避のブーツ", "回避のブーツ", "耐性のネックレス", "耐性のネックレス", "毒マスク", "追加装甲", "追加装甲", "追加装甲", "だんぼーる装甲",
        "炎のお守り", "氷のお守り", "雷のお守り", "光のお守り", "闇のお守り", "命中の靴", "学習装置", "菓子折", "天使の鏡", "魂の枷",
        "優先座席", "ポケットナイフ", "ポケットハンマー", "ブルマー", "ハニーグッズ", "ヒロシ君", "ビー玉", "オロチの鱗", "遺え～い", "クリスタル",
        "目録（エレノア）", "目録（ミル）", "目録（のぞみ）", "目録（カーマ）", "目録（シトモネ）", "目録（ウィチタ）", "目録（セル）", "きゃんきゃん", "９７チハ", "やもりん",
        "マジスコ", "クラーケン", "カニちゃん", "ちゃぷちゃぷ", "かえる女", "メイドさん", "ざしきわらし", "ちょーちん", "とっこーちゃん", "まじしゃん",
        "ねこまたまた", "バルキリー", "キャプテンバニラ", "ラルガのネコ", "バトルノート", "", "", "人間の破片Ａ", "人間の破片Ｂ", "人間の破片Ｃ",
        "人間の破片Ｄ", "人間の破片Ｅ", "禁断才能－Ｖ", "", "", "ローションＡ", "ローションＢ", "ローションＣ", "宝石", "クグの破片Ａ",
        "クグの破片Ｂ", "クグの破片Ｃ", "タマの下着", "タマの洋服", "", "傭兵タマ", "傭兵ばばあ", "赤っぽい羽", "キャラチケット", "まんが肉骨だけ",
        "まんが肉", "うさぎ鍋", "木彫りベアー", "鋼鉄ベアー", "純金ベアー", "しいたけ", "守りのまりも", "守り神様", "上手にむしられた魚", "ドラ猫の鈴",
        "タツノオトシドコロ", "腹痛の精神", "アホ毛", "愛フォーン", "はずれ棒", "身軽の羽", "避け茶漬け", "犬もあたる棒", "おんぶちゃん", "もじゃ人形",
        "足りない時計", "素早い変な虫", "ロケットエンジン", "傷だらけのＣＤ", "壊れきったラジオ", "ゲーモッチ", "溶けちゃう氷", "天使不在の空き箱", "衝撃のあるベルト", "のびのび麺",
        "空気の缶詰", "耐性宝冠", "壊れた時計", "神の仕様書", "禁断才能", "禁断才能－弱", "スキル戻し", "女魔物使い教本", "", "ＡＬＩＣＥ銀貨",
        "機々械々の破片", "葡萄", "うし", "バグ", "忍者とりもち", "ルリッカ", "鑑定士の墨", "絶望の鍵", "頑丈捕獲ロープ", "火縄銃改",
        "バイ・ロード", "リーザス赤将鎧", "ポスター筒", "体力ＵＰセット", "攻撃ＵＰセット", "防御ＵＰセット", "魔法ＵＰセット", "魔抵ＵＰセット", "回避ＵＰセット", "命中ＵＰセット",
        "素早さＵＰセット", "必殺ＵＰセット", "衝撃ＵＰセット", "耐性ＵＰセット", "トカゲよけ", "異常ブルマー", "白看護服", "黒看護服", "使い捨て白地図", "牢の鍵",
        "命中の靴", "ポケットハンマー", "ハニーキングの王冠", "学習装置改"
        }

End Class